package danielcortes.xyz.models.estado_resultado;

import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;

public class SQLiteEstadoResultadoDAO extends EstadoResultadoDAO {
    private SQLiteConnectionHolder connectionHolder;

    public SQLiteEstadoResultadoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<EstadoResultado> findAll() {
        List<EstadoResultado> estadoResultadoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from estado_resultado";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", new Object[]{query});

            estadoResultadoList = this.estadoResultadosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return estadoResultadoList;
    }

    @Override
    public EstadoResultado findById(int id) {
        EstadoResultado estadoResultado = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from estado_resultado where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            estadoResultado = this.estadoResultadosFromResultSet(rs).get(0);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return estadoResultado;
    }

    @Override
    public EstadoResultado findByMonth(YearMonth month) {
        EstadoResultado estadoResultado = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from estado_resultado where mes = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, month.atDay(1).toString());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, month});


            List<EstadoResultado> estadosResultado = this.estadoResultadosFromResultSet(rs);
            if (estadosResultado.size() > 0) {
                estadoResultado = estadosResultado.get(0);
            }

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return estadoResultado;
    }

    @Override
    public boolean insertEstadoResultado(EstadoResultado estadoResultado) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into estado_resultado (mes, costo_venta, cuenta_corriente_factura, cuenta_corriente_boleta, cuenta_corriente_sin_respaldo, remuneraciones, finiquitos, aguinaldo, bonos_personal, honorarios_contador, arriendo, agua, luz, gas, telefono, otro_servicio, ppm, ivaFavor) values (?, ?, ?, ?, ?, ? , ?, ? , ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
            PreparedStatement ps = conn.prepareStatement(query);

            ps.setString(1, estadoResultado.getMes().atDay(1).toString());
            ps.setInt(2, estadoResultado.getCostoVenta());
            ps.setInt(3, estadoResultado.getCuentaCorrienteFactura());
            ps.setInt(4, estadoResultado.getCuentaCorrienteBoleta());
            ps.setInt(5, estadoResultado.getCuentaCorrienteSinRespaldo());
            ps.setInt(6, estadoResultado.getRemuneraciones());
            ps.setInt(7, estadoResultado.getFiniquitos());
            ps.setInt(8, estadoResultado.getAguinaldo());
            ps.setInt(9, estadoResultado.getBonosPersonal());
            ps.setInt(10, estadoResultado.getHonorariosContador());
            ps.setInt(11, estadoResultado.getArriendo());
            ps.setInt(12, estadoResultado.getAgua());
            ps.setInt(13, estadoResultado.getLuz());
            ps.setInt(14, estadoResultado.getGas());
            ps.setInt(15, estadoResultado.getTelefono());
            ps.setInt(16, estadoResultado.getOtroServicio());
            ps.setDouble(17, estadoResultado.getPpm());
            ps.setDouble(18, estadoResultado.getIvaFavor());

            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7},{8},{9},{10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}] | updates: {19}", new Object[]{query, estadoResultado.getMes(), estadoResultado.getCostoVenta(), estadoResultado.getCuentaCorrienteFactura(), estadoResultado.getCuentaCorrienteBoleta(), estadoResultado.getCuentaCorrienteSinRespaldo(), estadoResultado.getRemuneraciones(), estadoResultado.getFiniquitos(), estadoResultado.getAguinaldo(), estadoResultado.getBonosPersonal(), estadoResultado.getHonorariosContador(), estadoResultado.getArriendo(), estadoResultado.getAgua(), estadoResultado.getLuz(), estadoResultado.getGas(), estadoResultado.getTelefono(), estadoResultado.getOtroServicio(), estadoResultado.getPpm(),estadoResultado.getIvaFavor(), updates});

            ps.close();

            query = "select last_insert_rowid()";
            ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            rs.next();
            estadoResultado.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateEstadoResultado(EstadoResultado estadoResultado) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update estado_resultado set mes = ?, costo_venta = ?, cuenta_corriente_factura = ?, cuenta_corriente_boleta = ?, cuenta_corriente_sin_respaldo = ?, remuneraciones = ?, finiquitos = ?, aguinaldo = ?, bonos_personal = ?, honorarios_contador = ?, arriendo = ?, agua = ?, luz = ?, gas = ?, telefono = ?, otro_servicio = ?, ppm = ?, ivaFavor = ? where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);

            ps.setString(1, estadoResultado.getMes().atDay(1).toString());
            ps.setInt(2, estadoResultado.getCostoVenta());
            ps.setInt(3, estadoResultado.getCuentaCorrienteFactura());
            ps.setInt(4, estadoResultado.getCuentaCorrienteBoleta());
            ps.setInt(5, estadoResultado.getCuentaCorrienteSinRespaldo());
            ps.setInt(6, estadoResultado.getRemuneraciones());
            ps.setInt(7, estadoResultado.getFiniquitos());
            ps.setInt(8, estadoResultado.getAguinaldo());
            ps.setInt(9, estadoResultado.getBonosPersonal());
            ps.setInt(10, estadoResultado.getHonorariosContador());
            ps.setInt(11, estadoResultado.getArriendo());
            ps.setInt(12, estadoResultado.getAgua());
            ps.setInt(13, estadoResultado.getLuz());
            ps.setInt(14, estadoResultado.getGas());
            ps.setInt(15, estadoResultado.getTelefono());
            ps.setInt(16, estadoResultado.getOtroServicio());
            ps.setDouble(17, estadoResultado.getPpm());
            ps.setDouble(18, estadoResultado.getIvaFavor());
            ps.setInt(19, estadoResultado.getId());

            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7},{8},{9},{10}, {11}, {12}, {13}, {14}, {15}, {16}, {17}, {18}, {19}] | updates: {20}", new Object[]{query, estadoResultado.getMes(), estadoResultado.getCostoVenta(), estadoResultado.getCuentaCorrienteFactura(), estadoResultado.getCuentaCorrienteBoleta(), estadoResultado.getCuentaCorrienteSinRespaldo(), estadoResultado.getRemuneraciones(), estadoResultado.getFiniquitos(), estadoResultado.getAguinaldo(), estadoResultado.getBonosPersonal(), estadoResultado.getHonorariosContador(), estadoResultado.getArriendo(), estadoResultado.getAgua(), estadoResultado.getLuz(), estadoResultado.getGas(), estadoResultado.getTelefono(), estadoResultado.getOtroServicio(), estadoResultado.getPpm(),estadoResultado.getIvaFavor(), estadoResultado.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteEstadoResultado(EstadoResultado estadoResultado) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from estado_resultado where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, estadoResultado.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, estadoResultado.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }
}
